Index: /main/trunk/greenstone3/web/WEB-INF/classes/interface_basic.properties
===================================================================
--- /main/trunk/greenstone3/web/WEB-INF/classes/interface_basic.properties	(revision 26392)
+++ /main/trunk/greenstone3/web/WEB-INF/classes/interface_basic.properties	(revision 26392)
@@ -0,0 +1,407 @@
+#***** IMAGE URLS *****
+expand_image=interfaces/__INTERFACE_NAME__/images/expand.png
+collapse_image=interfaces/__INTERFACE_NAME__/images/collapse.png
+page_image=interfaces/__INTERFACE_NAME__/images/page.png
+chapter_image=interfaces/__INTERFACE_NAME__/images/chapter.png
+realistic_books_image=interfaces/__INTERFACE_NAME__/images/rbook.png
+slideshow_image=interfaces/__INTERFACE_NAME__/images/slideshow.png
+highlight_image=interfaces/__INTERFACE_NAME__/images/hl.png
+bookshelf_image=interfaces/__INTERFACE_NAME__/images/bookshelf.png
+book_image=interfaces/__INTERFACE_NAME__/images/book.png
+loading_image=interfaces/__INTERFACE_NAME__/images/loading.gif
+page_icon_image=interfaces/__INTERFACE_NAME__/images/itext.gif
+trash_full_image=interfaces/__INTERFACE_NAME__/images/trash-full.png
+blank_image=interfaces/__INTERFACE_NAME__/images/blankImage.png
+next_image=interfaces/__INTERFACE_NAME__/images/next.png
+prev_image=interfaces/__INTERFACE_NAME__/images/previous.png
+zoom_image=interfaces/__INTERFACE_NAME__/images/zoom.png
+left_arrow_image=interfaces/__INTERFACE_NAME__/images/leftarrow.png
+float_toc_image=interfaces/__INTERFACE_NAME__/images/floattoc.png
+
+#***** TEXT FRAGMENTS *****
+gsdl=Greenstone Digital Library Software
+gs3power=powered by greenstone3
+error=Error:
+# the buttons
+about_b=ABOUT
+home_b=Home
+help_b=Help
+pref_b=Preferences
+debuginfo_b=Debug info
+login_b=Login
+logout_b=Logout
+loggedin_b=Logged in as 
+# tool tips for the buttons
+home_tip=Library home page
+help_tip=Help pages
+pref_tip=Change your interface preferences
+debuginfo_tip=Display debug view options
+login_tip=Login
+logout_tip=Logout
+# page titles
+help_t=Help
+pref_t=Preferences
+home_t=Home
+aboutpage=About page
+textframebrowser=You must have a frame enabled browser to view this.
+home.quick_search=Quick Search
+home.librarian_interface=The Librarian Interface
+home.select_a_collection=Select a collection
+# other
+minimize=minimize
+expand=expand
+open_book=Open this document and view contents
+close_book=Close this book and return to search/browse
+open_folder=Open this folder and view contents
+close_folder=Close this folder
+view_document=View the document
+
+######################
+# system page
+#######################
+system.title=System Request
+######################
+# about page
+#######################
+about.noservices=There are no services available for this collection.
+about.services=Extra services available:
+about.servicehelp=You can access the services by clicking on the buttons below or on the names on the navigation bar. The navigation bar is persistent across all pages in the collection.
+#about.description=Description:
+about.metadata=Metadata:
+
+#######################
+# query page
+########################
+query=Search
+query.wordcount=Word count:
+query.nodocsmatch=No documents match the query.
+query.onedocsmatch=One document matches the query.
+query.manydocsmatch={0} documents match the query.
+query.atleastdocsmatch=At least {0} documents match the query.
+query.docsreturned={0} documents returned.
+query.results=Results
+query.matches=Matches
+
+query.occurs=occurs
+query.time=time
+query.time_plural=times
+query.in=in
+query.document=document
+query.document_plural=documents
+query.section=section
+query.section_plural=sections
+
+# eg Displaying 1 to 20 of 42 sections/documents
+query.displayingnumdocs=Displaying {0-startnum} to {1-endnum} of {2-totalnum} {3-level-plural}
+
+#query.the_term=The term
+#query.common_word=is too common and has been excluded from the search
+query.common=The following terms are too common and have been excluded from the search:
+
+##################
+# prefs page
+##################
+pref.searchpref=Search preferences
+pref.prespref=Presentation preferences
+pref.interfacelang=Interface language:
+pref.encoding=Encoding:
+pref.hitsperpage=Number of hits per page:
+pref.maxDocs=Maximum documents to return:
+pref.all=all
+pref.set_prefs=Set preferences
+pref.berrybasket=Berry basket
+pref.berrybasket.on=on
+pref.berrybasket.off=off
+pref.book=Book viewer mode: 
+pref.formatedit=Format edit mode
+pref.formatedit.on=on
+pref.formatedit.off=off
+pref.theme=Visual theme
+
+##################
+# document page
+##################
+doc.loading=loading
+doc.filter_pages=Filter pages
+
+doc.edit_content=Edit content
+doc.hide_editor=Hide editor
+doc.edit_structure=Edit structure
+
+doc.zoom=Zoom
+doc.zoom_size=Size
+
+doc.highlightTooltip=Enable or disable search term highlighting
+doc.realisticBooksTooltip=Enable or disable the realistic books view
+doc.zoomTooltip=Enable or disable zooming images in the standard view
+doc.slideshowTooltip=Enable or disable the slide show view
+doc.floatingTooltip=Fix the table of contents to the right side of the screen
+
+doc.document=Document
+doc.pageof=Page {0} of {1}.
+doc.pages={0} pages.
+doc.gotopage=Go to page
+doc.expand_doc_b=EXPAND<br />DOCUMENT
+doc.expand_doc_tip=Display the entire document
+doc.contract_doc_b=CONTRACT<br />DOCUMENT
+doc.contract_doc_tip=Return to previously selected section
+doc.expand_contents_b=EXPAND<br />CONTENTS 
+doc.expand_contents_tip=Expand only the table of contents
+doc.contract_contents_b=CONTRACT<br />CONTENTS
+doc.contract_contents_tip=Collapse the table of contents
+doc.detach_page_b=DETACH<br />PAGE
+doc.detach_page_tip=Open this page in a new window
+doc.back_to_top=back to top
+
+doc.table_of_contents=Table of contents
+doc.close_toc=Close the table of contents
+doc.open_toc=Open the table of contents
+
+doc.maps.nearby_docs=Show documents near here
+maps.scrolllabel=Scroll through places
+
+external.title=External Link
+external.text=The link you have selected is external to any of your currently selected collections. If you still wish to view this link and your browser has access to the Web, you can {0} to this page; otherwise use your browsers "back" button to return to the previous document.
+external.go_forward=go forward
+
+##################
+# help page
+##################
+help.topicstitle=<h2>Topics</h2>
+
+help.findinginformationtitle=<h2>How to find information in the {0} collection</h2>
+help.findinginformation=There are {0} ways to find information in this collection:
+help.searchdesc=search for particular words that appear in the text by clicking the Search button
+help.browsedesc=browse documents by <i>{0}</i> by clicking the <i>{0}</i> button
+
+help.readingdocstitle=<h2>How to read the documents</h2>
+help.readingdocs=<p>You can tell when you have arrived at an individual book or document because its title, \
+or an image of the front cover, appears at the top left of the page. In some collections, a table of contents appears, \
+while in others (eg. when the paged image option is used) just the page number is shown, along with a box that allows you \
+to select a new page and go forward and backward. In the table of contents, the current section heading is in bold face, \
+and the table is expandable -- click on the folders to open or close them; click on the open book at the top to close it.</p>\
+<p>Underneath is the text of the current section. When you have read through it, there are arrows at the \
+bottom to take you on to the next section or back to the previous one.</p>\
+<p>Below the title or front-cover image are some buttons. Click on <i>EXPAND DOCUMENT</i> to expand out the whole text \
+of the current section, or book. If the document is large, this could take a long time and use a lot of memory! \
+Click on <i>EXPAND CONTENTS</i> to expand out the whole table of contents so that you can see the titles of all \
+chapters and subsections. Click on <i>DETACH PAGE</i> to make a new browser window for this document. \
+(This is useful if you want to compare documents, or read two at once.)</p>
+
+help.openbookshelf=Open this bookshelf
+help.sectionarrows=Go to the previous/next section
+
+help.searchingtitle=<h2>How to search for particular words</h2>
+help.searching=<p>From the search page, you make a query in these simple steps:</p>\
+<ol><li>Specify what items you want to search</li>\
+<li>Say whether you want to search for all or just some of the words</li>\
+<li>Type in the words you want to search for</li>\
+<li>Click the <i>Begin Search</i> button</li>\
+</ol>\
+<p>When you make a query, the titles of twenty matching documents will be shown. \
+There is a button at the end to take you on to the next twenty documents.  From \
+there you will find buttons to take you on to the third twenty or back to the \
+first twenty, and so on.  Click the title of any document, or the little button \
+beside it, to see it.</p>\
+<p>A maximum of 50 is imposed on the number of \
+documents returned.  You can change this number by clicking the \
+<i>PREFERENCES</i> button at the top of the page.</p>
+
+help.querytermstitle=<h3>Search Terms</h3>
+help.queryterms=<p>Whatever you type into the query box is interpreted as a list of words or phrases \
+called "search terms."  A term is a single word containing only letters and digits, or a phrase \
+consisting of a sequence of words enclosed in double quotes ("...").  Terms are separated by white spaces. \
+If any other characters such as punctuation appear, they serve to separate terms just as though they were \
+spaces.  And then they are ignored.  You can't search for words that include punctuation.</p> \
+<p>For example, the query</p> \
+<ul><kbd>Agro-forestry in the Pacific Islands: Systems for Sustainability (1993)</kbd></ul> \
+<p>will be treated the same as</p> \
+<ul><kbd>Agro forestry in the Pacific Islands  Systems for Sustainability  1993 </kbd></ul>
+
+help.querytypetitle=<h3>Query type</h3>
+help.querytype=<p>There are two different kinds of query. </p>\
+<ul>\
+<li>Queries for <b>all</b> of the words.  These look for documents (or chapters, or titles) \
+that contain all the words you have specified. Documents that satisfy the query are displayed, in build order. </li>\
+<li>Queries for <b>some</b> of the words.  Just list some terms that are likely to appear in \
+the documents you are looking for.  Documents are displayed in order of how closely they match the query. \
+When determining the degree of match, </li>\
+<ul> \
+<li> the more search term occurrences a document contains, the closer it matches; </li>\
+<li> terms which are rare in the collection as a whole are more important than common ones; </li>\
+<li> short documents match better than long ones. </li>\
+</ul> \
+</ul> \
+<p>Use as many search terms as you like--a whole sentence, or even a whole paragraph.  If you specify only \
+one term, documents will be ordered by its frequency of occurrence.</p>
+
+help.queryscopetitle=<h3>Scope of queries</h3>
+help.queryscope=<p>In most collections you are given a choice of different indexes to search. For example, there might \
+be author or title indexes. Or there might be chapter or paragraph indexes. Generally, \
+the full matching document is returned regardless of which index you search.</p> \
+<p>If documents are books, they will be opened at the appropriate place.</p>
+
+help.changingpreferencestitle=<h2>Changing your preferences</h2>
+help.changingpreferences=<p>When you click the <i>PREFERENCES</i> button at the top of the page you will \
+be able to change some features of the interface to suit your own requirements.</p>
+
+help.collectionpreferencestitle=<h3>Collection preferences</h3>
+help.collectionpreferences=<p>Some collections comprise several subcollections, which can be searched \
+independently or together, as one unit.  If so, you can select which \
+subcollections to include in your searches on the Preferences page. </p>
+
+help.languagepreferencestitle=<h3>Language preferences</h3>
+help.languagepreferences=<p>Each collection has a default presentation language, but you can switch to \
+a different language if you like.  You can also alter the encoding scheme \
+used by Greenstone for output to the browser -- the software chooses \
+sensible defaults, but with some browsers it may be necessary to switch to \
+a different encoding scheme to ensure correct character display. \
+All collections allow you to switch from the standard graphical interface format to a textual one. This \
+is particularly useful for visually impaired users who use large screen fonts or speech synthesizers for output.</p>
+
+help.presentationpreferencestitle=<h3>Presentation preferences</h3>
+help.presentationpreferences=<p>Depending on the particular collection, \
+there may be several options you can set that control the presentation. </p> \
+<p>Collections of Web pages allow you to suppress the Greenstone navigation bar at the top of each document page, \
+so that once you have done a search you land at the exact Web page that matches without any Greenstone header. \
+To do another search you will have to use your browser's "back" button. These collections also allow you to suppress \
+Greenstone's warning message when you click a link that takes you out of the digital library collection and on to the \
+Web itself. And in some Web collections you can control whether the links on the search results page take you straight \
+to the actual URL in question, rather than to the digital library's copy of the page. </p>
+
+help.searchpreferencestitle=<h2>Search preferences</h2>
+help.searchpreferences1=<p>You can switch to an "advanced" query mode which allows you to combine terms \
+using &amp; (for "and"), | (for "or"), and ! (for "not"), using parentheses for \
+grouping if desired. This allows you to specify more precise queries. </p>\
+<p>It is possible to get a large query box, so that you can easily do paragraph-sized searching. \
+It is surprisingly quick to search for large amounts of text. </p>\
+
+help.searchpreferences2=<p>You can turn on the search history feature, which shows you your last few \
+queries.  This makes it easy to repeat slightly modified versions of previous queries.</p> \
+<p>Finally, you can control the number of hits returned, and the \
+number presented on each screenful.</p>
+
+help.mgsearchpreferences=<p>A pair of buttons controls whether upper and lower case must match when searching. \
+For example, if "ignore case differences" is selected, snail farming will be treated the same as Snail Farming and SNAIL FARMING. </p>
+
+##################
+# authentication page
+##################
+authen.login_descibe_line_1=The page you have requested requires you to sign in.
+authen.login_descibe_line_2=[Note that you must belong to the "administrator" group to access this page]
+authen.login_descibe_line_3=Please enter your Greenstone username and password.
+authen.no_permission=Sorry, you do not have permission to access this page.
+authen.username=Username
+authen.username_describe=Usernames must be between 2 and 30 characters long. They can contain alphanumeric characters, '.', and '_'.
+authen.password=Password
+authen.password_describe=Passwords must be between 3 and 8 characters long. They can contain any normal printable ASCII characters.
+authen.account_status=Account status
+authen.enabled=enabled
+authen.disabled=disabled
+authen.groups=Groups
+authen.add_group=Add Group
+authen.groups_describe=Groups is a comma separated list.
+authen.comment=Comment
+authen.email=Email address
+authen.add_a_new_user_title=Add a New User
+authen.change_password_title=Change password
+authen.change_password_login_describe_line_1=The page you have requested requires you to sign in.
+authen.change_password_login_describe_line_2=Please enter your Greenstone username and password.
+authen.change_password_describe_line_1=Passwords must be between 3 and 8 characters long. They can contain any normal printable ASCII characters.
+authen.old_password=Old password
+authen.new_password=New password
+authen.retype_password=Retype password
+authen.change_password_successed_title=Change password
+authen.change_password_successed_content=Your password was successfully changed.
+authen.old_password_warning=The old password was incorrect.
+authen.new_retype_password_warning=Enter your new password and then retype it.
+authen.two_password_not_match=The two versions of your new password did not match.
+authen.password_empty_warning=Either the new password or the retyped password cannot be empty.
+authen.password_initial=Please enter an initial password for this user.
+authen.new_password_invalid=The new password is invalid.
+authen.retyped_password_invalid=The retyped password is invalid.				 
+authen.username_password_empty_warning=Either the username or the new password cannot be empty.
+authen.edit_user_information=Edit User Information
+authen.do_you_really_want_to_permanently_remove_user=Do you really want to permanently remove user "
+authen.user_has_existed=The user name has existed in the users table, choose an unique one.
+authen.unsername_err=The username is invalid
+authen.password_err=The password is invalid			 
+authen.wrong_password_warning=Either your username or password was incorrect.
+authen.list_of_current_users_title=List of current users
+authen.delete_warning=Are you sure you want to delete user 
+authen.edit=Edit
+authen.delete=Delete
+authen.sign_in=sign in
+authen.account_status_false=The account is disabled, request Administrator for more information.
+authen.authentication=Administration Page
+authen.greenstone_home=Greenstone home
+authen.list_users=list users
+authen.add_a_new_user=Add a New User
+authen.change_password=change password
+authen.logout=logout
+authen.login=login
+authen.login_successfully=Login successful
+authen.register=Register
+authen.account_settings=Account Settings
+authen.change_password=Change Password
+authen.reset_password=Reset Password
+authen.status=Status
+authen.submit=Submit
+authen.error_failed_to_add=Error: Failed to add user
+authen.user_added_success=User added successfully
+authen.page_not_found=Page not found
+
+###################
+# Document basket #
+###################
+db.doc_basket=Document basket
+db.access_denied=Access Denied
+db.no_collection_building=You cannot use this feature of Greenstone as you do not have collection building enabled
+
+#############################
+# Document structure editor #
+#############################
+dse.no_docs=No documents in the Document Basket
+dse.untitled=UNTITLED DOCUMENT
+dse.delete_section=delete section
+dse.edit=edit
+dse.hide=hide
+dse.add_sub_section=add sub-section
+dse.duplicate=duplicate
+dse.error_saving=There was an error saving, aborting
+dse.save_changes=Save changes
+dse.saving=Saving
+dse.modifying_archives=Modifying archive files
+dse.empty_collection_list=List of collections to build is empty
+dse.could_not_build_p1=Could not build collection
+dse.could_not_build_p2=, aborting the building operation
+dse.could_not_activate_p1=Could not activate collection
+dse.could_not_activate_p2=, aborting the activation operation
+dse.activating=Activating collection
+dse.building=Building collection
+dse.could_not_check_status_p1=Could not check status of
+dse.could_not_check_status_p2a=, there was an error in the XML, aborting the operation
+dse.could_not_check_status_p2b=, there was an error on the server, aborting the operation
+dse.error_saving_changes=There was an error saving your changes
+dse.error_code=Error Code
+dse.error_reason=Error Reason
+dse.error_line=Error Line
+dse.xml_error=There was an error parsing the XML
+dse.browse_cannot_validate_xml=Your browser cannot handle XML validation
+dse.add_new_metadata=Add new metadata
+dse.no_value_given=No value given for new metadata name
+dse.create_new_document=Create new document
+dse.untitled_section=UNTITLED SECTION
+dse.insert_new_section=Insert new section
+
+###################
+# DebugInfo  #
+###################
+debuginfo.usage=When debugging the XSLT, you can append any of the following to the URL (prefixed with a & or ? as appropriate) to see the intermediate XML that's produced.
+debuginfo.xml=Displays the raw information coming from the Message Router.
+debuginfo.xmlfinal=Displays the information coming from the Message Router after the second config_format pass.
+debuginfo.skindoc=Simplified Skin XSL with Expanded GSF statements appended.
+debuginfo.skinandlib=An XML document with a root element called skinAndLibraryXsl and the two children skinXsl and libraryXsl. The libraryXsl, which already includes util.xsl, is merely appended.
+debuginfo.skinandlibdoc=The result of applying preprocess.xsl to skinandlib produces this stylesheet which is the final XSL document that will be applied to the XML data returned from the message router.
+debuginfo.formatedit=Web interface editor for editing Greenstone3 format statements.
+