Index: gs3-extensions/fedora/README
===================================================================
--- gs3-extensions/fedora/README	(revision 26391)
+++ gs3-extensions/fedora/README	(revision 26404)
@@ -550,7 +550,11 @@
 8. With tomcat running, configure fedoragsearch, which will adjust various config files. You will need to go into the deployed fedoragsearch webapps folder's FgsConfig folder first to be able to run the configuration target:
 
-<GS3>/packages/tomcat/webapps/fedoragsearch/FgsConfig>ant -f fgsconfig-basic.xml
-
-9. Run tomcat and check fedoragsearch has been properly installed by visiting:
+	<GS3>/packages/tomcat/webapps/fedoragsearch/FgsConfig>ant -f fgsconfig-basic.xml
+
+9. With tomcat still running, run updateIndex once to create the empty index for the first time (by running the runRESTClient.sh script with the command: "host:port updateIndex createEmpty [indexName]")
+
+	./<GS3>/packages/tomcat/webapps/fedoragsearch/client/runRESTClient.sh localhost:8383 updateIndex createEmpty FgsIndex
+
+10. Check fedoragsearch has been properly installed by visiting:
 http://localhost:8383/fedoragsearch/rest
 
Index: gs3-extensions/fedora/build.xml
===================================================================
--- gs3-extensions/fedora/build.xml	(revision 26391)
+++ gs3-extensions/fedora/build.xml	(revision 26404)
@@ -15,4 +15,6 @@
 
   <!-- PROPERTIES -->
+
+  <!-- need to have FEDORA_HOME env correctly defined -->
 
   <!--<property name="gsdl3src.home" value="../..${basedir}"/>-->
@@ -96,6 +98,6 @@
       *********************************************************
       1. Adjust ${gsdl3src.home}/build.properties to set up Fedora.
-      2. Then restart the Greenstone tomcat. Once it's started up, 
-      3. Return to this extension directory and run: ant continue-fedora-install
+      2. Then restart the Greenstone 3 tomcat. This will take some time the first time around. 
+      3. Once tomcat's started up, return to this extension directory and run: ant continue-fedora-install
       *********************************************************
     </echo>
@@ -111,15 +113,53 @@
     <!-- call the fgsconfig-basic.xml buildfile in GS3/packages/tomcat/webapps/fedoragsearch/FgsConfig's 
 	 ant -f fgsconfig-basic.xml -->
+    <echo>
+      Configuring Fedora GSearch
+    </echo>
     <ant dir="${gsdl3src.home}/packages/tomcat/webapps/fedoragsearch/FgsConfig" antfile="fgsconfig-basic.xml"/>
     
     <!-- give read execute permissions to all (755) for the fedoragsearch files -->
+    <echo>
+      Giving executable permissions to Fedora GSearch scripts
+    </echo>
     <chmod file="${gsdl3src.home}/packages/tomcat/webapps/fedoragsearch/client/runRESTClient.sh" perm="755"/>
     <chmod file="${gsdl3src.home}/packages/tomcat/webapps/fedoragsearch/client/runSOAPClient.sh" perm="755"/>
     
+    <!-- call Update EmptyIndex on GSearch to create the initial index (segments) file:
+	 .../webapps/fedoragsearch/client/runRESTClient.sh <host:port> updateIndex createEmpty <indexName>    
+
+	 Where the indexName is FgsIndex. If it is made customisable, then template files need 
+	 to change to contain placeholders wherever the indexName is mentioned.
+	 To run the upateIndex command, need GSearch username and pwd set in the environment. -->
+    <echo>
+      Calling UpdateIndex CreateEmpty on Fedora GSearch to create a new index
+    </echo>
+    <exec osfamily="unix" spawn="false"
+	  executable="${gsdl3src.home}/packages/tomcat/webapps/fedoragsearch/client/runRESTClient.sh">	  
+      <env key="fgsUserName" value="fedoraAdmin"/>
+      <env key="fgsPassword" value="${fedora.password}"/>
+      <arg value="${tomcat.server}:${tomcat.port}"/>
+      <arg value="updateIndex"/>
+      <arg value="createEmpty"/>
+      <arg value="FgsIndex"/>
+    </exec>
+    
+    <exec osfamily="windows" spawn="false"
+	  executable="cmd">
+      <env key="fgsUserName" value="fedoraAdmin" />
+      <env key="fgsPassword" value="${fedora.password}" />
+      <arg value="/c"/>
+      <arg value="${gsdl3src.home}\\packages\\tomcat\\webapps\\fedoragsearch\\client\\runRESTClient.bat"/>
+      <arg value="${tomcat.server}:${tomcat.port}" />
+      <arg value="updateIndex" />
+      <arg value="createEmpty" />
+      <arg value="FgsIndex" />
+    </exec>
+
     <echo>
       *********************************************************
-      1. Stop the Greenstone Tomcat. (Check it's stopped: ps aux | grep tomcat)
-      2. Then to complete fedora installation, return to this extension directory and run: ant finish-fedora-install.
-      This will clear the war files since they have already been deployed.
+      0. Don't worry about the IndexNotFoundException message. It always does this.
+      1. Stop your Greenstone 3 tomcat. (Check it's stopped: ps aux | grep tomcat)
+      2. Then, to complete fedora installation, return to this extension directory and run: ant finish-fedora-install.
+      This will clear the war files, since they have already been deployed by now.
       *********************************************************
     </echo>