Index: gs3-extensions/fedora/trunk/src/README
===================================================================
--- gs3-extensions/fedora/trunk/src/README	(revision 26417)
+++ gs3-extensions/fedora/trunk/src/README	(revision 26420)
@@ -6,4 +6,5 @@
 
 B. How to manually build fedora collections
+	Deleting a Fedora GS3 collection
 
 C. The customisations that have been made for the extension
@@ -35,4 +36,5 @@
 
 0. You will need Greenstone 3.05 or a fresh checkout from SVN, already installed.
+You need a fresh x-term, one where the GS3 environment hasn't already been set up in.
 
 1. Download the Fedora Extension for Greenstone 3: http://trac.greenstone.org/browser/gs3-extensions/fedora/trunk/fedora3-gs3ext.tar.gz
@@ -43,5 +45,10 @@
 	$ tar -xvzf fedora3-gs3ext.tar.gz
 
-4. This will create a fedora3 folder in your Greenstone3/ext folder. 
+This will create a fedora3 folder in your Greenstone3/ext folder. 
+
+4. Go to your Greenstone3 toplevel folder and now finally set up the GS3 environment:
+	$ source gs3-setup.sh	
+
+This will now also have set up the fedora extension environment, such as FEDORA_HOME, FEDORA_VERSION and a PATH variable adjusted for Fedora.
 
 5. Open Greenstone3/build.properties and find the section:
@@ -146,7 +153,9 @@
 
 3. Create a new collection with mkcol.pl. Call it "fedora1" for example 
-	mkcol.pl -collectdir /<GS3>/web/sites/localsite/collect fedora1
-
-4. Run import and build to ingest the new collection
+	mkcol.pl -site localsite fedora1
+
+(Deprecated: mkcol.pl -gs3mode -collectdir /<GS3>/web/sites/localsite/collect fedora1)
+
+4. Run import and build to ingest the new collection. Make sure to use the correct host and port, as specified in your /<GS3>/build.properties file.
 
 - First put the documents you want into the import directory of your new collection.
@@ -158,26 +167,5 @@
 
 
-5. If building the GS3 demo collection as a fedora collection:
- 
-- use FLI to transfer dls to dc metadata upon Gathering the documents.
-- then before building, turn on the description_tags in the HTMLPlugin.
-
-
-IMPORTANT NOTE: Fedora GSearch for some reason doesn't like the images in the default GS3 demo collection and is unable to index the documents because of them.
-If using the default GS3 demo collection, all the images -- both png and jpg alike -- need to first be resaved as their respective file types.
-Use Imagemagick to resave the many pngs, by going into each document's subfolder of the import folder and running:
-	mogrify -format png *.png
-
-Also open each folder's jpg document cover image in GIMP and resave under the same name (at 100% quality).
-
-
-6. If you ran FLI, exit it. It should stop the Greenstone server.
-
-With fedora installed, it's always good to check that the java process that launched tomcat has indeed stopped:
-	ps aux | grep "tomcat"
-
-(Since things will fail if multiple instances of this same tomcat are running, kill any java processes that are referring to tomcat.)
-
-7. Create an index folder in the new fedora collection folder. Create a buildConfig.xml file in it containing the following:
+NOTE: The buildcol step would have created an index folder in the new fedora collection folder with a buildConfig.xml file in it containing the following:
 
 <buildConfig> 
@@ -189,20 +177,52 @@
 
 
-8. Restart the GS3 server.
+5. If building the GS3 demo collection as a fedora collection:
+ 
+- use FLI to transfer dls to dc metadata upon Gathering the documents.
+- then before building, turn on the description_tags in the HTMLPlugin.
+
+
+IMPORTANT NOTE: Fedora GSearch for some reason doesn't like the images in the default GS3 demo collection and is unable to index the documents because of them.
+If using the default GS3 demo collection, all the images -- both png and jpg alike -- need to first be resaved as their respective file types.
+Use Imagemagick to resave the many pngs, by going into each document's subfolder of the import folder and running:
+	mogrify -format png *.png
+
+Also open each folder's jpg document cover image in GIMP and resave under the same name (at 100% quality).
+
+
+6. If you ran FLI, exit it. It should stop the Greenstone server.
+
+With fedora installed, it's always good to check that the java process that launched tomcat has indeed stopped:
+	ps aux | grep "tomcat"
+
+(Since things will fail if multiple instances of this same tomcat are running, kill any java processes that are referring to tomcat.)
+
+
+7. Restart the GS3 server.
 	ant start
 
-9. Visit the collection from the Greenstone collections page
-
-10. Deleting a Fedora GS3 collection requires the collection's documents and the collection file to be purged from the Fedora repository and removed from the Fedora Gsearch index. (In the case of a normal GS3 collection, just the GS3 collection's directory will be deleted.) There's now a script to delete a Greenstone Fedora collection which will take care of these additional steps if you are manually managing your collections. (FLI calls this script when a collection is deleted from FLI.)
+8. To activate the collection, first visit the web page
+http://<host>:<port>/greenstone3/library?a=s&sa=a&st=collection&sn=<COLNAME>
+
+9. Then visit the collection from the Greenstone collections page
+
+
+*****************************************
+DELETING A FEDORA GS3 COLLECTION
+*****************************************
+
+Deleting a fedora GS3 collection requires the collection's documents and the collection file to be purged from the Fedora repository and removed from the Fedora Gsearch index. (In the case of a normal GS3 collection, just the GS3 collection's directory will be deleted.) There's now a script to delete a Greenstone Fedora collection which will take care of these additional steps if you are manually managing your collections. (FLI calls this script when a collection is deleted from FLI.)
+
 
 Deleting a Fedora GS3 collection is accomplished with the following 2 steps:
-- Run the g2f-deletecol.pl script over the collection to be deleted. Assuming the collection is called fedora1, you'd run:
+
+1. Run the g2f-deletecol.pl script over the collection to be deleted. Assuming the collection is called fedora1, you'd run:
 	g2f-deletecol.pl -hostname localhost -port 8383 -password pounamu -collectdir /<GS3>/web/sites/localsite/collect fedora1
-- manually delete the Greenstone collection directory from the filesystem
+2. Manually delete the Greenstone collection directory from the filesystem
 
 
 To run this manually, 
 - first remove the pids from the GSearch index:
-/<GS3>/packages/tomcat/webapps/fedoragsearch/client>/<GS3>/packages/tomcat/webapps/fedoragsearch/client/runRESTClient.sh localhost:8383 updateIndex deletePID greenstone:fedora1-HASH010313b14474bc72b296b15f
+/<GS3>/packages/tomcat/webapps/fedoragsearch/client>/<GS3>/packages/tomcat/webapps/fedoragsearch/client/runRESTClient.sh localhost:8383 updateIndex deletePID <greenstone:fedora1-HASH010313b14474bc72b296b15f>
 
 It will ask for the fedoragsearch username and password, which by default are fedoraAdmin and pounamu, respectively.
@@ -222,4 +242,5 @@
 You can also visit http://localhost:8383/fedoragsearch/rest?operation=gfindObjects
 then you can search for a query term by prefixing the index field to it, e.g ds.fulltext:computers 
+
 
 
Index: gs3-extensions/fedora/trunk/src/build.xml
===================================================================
--- gs3-extensions/fedora/trunk/src/build.xml	(revision 26417)
+++ gs3-extensions/fedora/trunk/src/build.xml	(revision 26420)
@@ -120,5 +120,5 @@
     <!-- give read execute permissions to all (755) for the fedoragsearch files -->
     <echo>
-      Giving executable permissions to Fedora setup script and GSearch scripts
+      Giving executable permissions to Fedora setup script and Fedora GSearch scripts
     </echo>
     <chmod file="${basedir}/gs3-setup.sh" perm="755"/>