Index: gs3-extensions/fedora/trunk/src/README
===================================================================
--- gs3-extensions/fedora/trunk/src/README	(revision 26420)
+++ gs3-extensions/fedora/trunk/src/README	(revision 26434)
@@ -4,4 +4,5 @@
 
 A. To install your GS3 Fedora extension from fedora3-gs3ext.tar.gz
+	Uninstalling Fedora
 
 B. How to manually build fedora collections
@@ -21,5 +22,5 @@
 Fedora GSearch 2.5
 
-Web services pages once installed: 
+Web services pages once installed (by default GS3 is set to use localhost:8383): 
 http://localhost:8383/fedora/services
 http://localhost:8383/fedoragsearch/services
@@ -58,4 +59,5 @@
 	#fedora.maxpermsize=-XX:MaxPermSize=128m
 	#fedora.password=pounamu
+	#index.writelock.timeout=10000
 
 Uncomment all these properties and change the value for the fedora password if necessary:
@@ -65,5 +67,5 @@
 	fedora.maxpermsize=-XX:MaxPermSize=128m
 	fedora.password=pounamu		
-
+	index.writelock.timeout=10000
 
 6. Use a terminal to go into this folder:
@@ -89,4 +91,6 @@
 	$ ./gli/fli.sh
 
+
+9. Once you've tested everything is working, you may want to set logging level of Fedora GSearch to log ERRORs rather than all DEBUG statements. See the Debugging section in this file.
 
 
@@ -138,4 +142,19 @@
 
 
+*****************************************
+UNINSTALLING FEDORA
+*****************************************
+
+1. Make sure tomcat is stopped.
+
+2. Go to /GS3/ext/fedora3 and run:
+	ant uninstall-fedora
+
+The above will remove 
+- the deployed webapps (fedora, fedoragsearch, fedora-demo, fop, imagemanip and saxon.war)
+- as well as the ext/fedora3 folder itself.
+
+
+
 ********************************************************************************************************************
 					B. Manual building of fedora collections
@@ -152,8 +171,8 @@
 	source gs3-setup.bash
 
-3. Create a new collection with mkcol.pl. Call it "fedora1" for example 
-	mkcol.pl -site localsite fedora1
-
-(Deprecated: mkcol.pl -gs3mode -collectdir /<GS3>/web/sites/localsite/collect fedora1)
+3. Create a new collection with mkcol.pl.
+	mkcol.pl -site localsite <COLNAME>
+
+(Deprecated: mkcol.pl -gs3mode -collectdir /<GS3>/web/sites/localsite/collect <COLNAME>)
 
 4. Run import and build to ingest the new collection. Make sure to use the correct host and port, as specified in your /<GS3>/build.properties file.
@@ -161,8 +180,8 @@
 - First put the documents you want into the import directory of your new collection.
 
-- g2f-import.pl -hostname localhost -port 8383 -password pounamu -removeold -collectdir /<GS3>/web/sites/localsite/collect fedora1
+- g2f-import.pl -hostname localhost -port 8383 -password pounamu -removeold -collectdir /<GS3>/web/sites/localsite/collect <COLNAME>
 (password may be optional at this stage, by include it for convenience)
 
-- g2f-buildcol.pl -hostname localhost -port 8383 -password pounamu -removeold -collectdir /<GS3>/web/sites/localsite/collect fedora1
+- g2f-buildcol.pl -hostname localhost -port 8383 -password pounamu -removeold -collectdir /<GS3>/web/sites/localsite/collect <COLNAME>
 
 
@@ -181,4 +200,9 @@
 - use FLI to transfer dls to dc metadata upon Gathering the documents.
 - then before building, turn on the description_tags in the HTMLPlugin.
+Or manually add to the etc/collectionConfig.xml of the demo collection:
+
+	<plugin name="HTMLPlugin">
+	  <option name="-description_tags"/>
+	</plugin>
 
 
@@ -190,5 +214,4 @@
 Also open each folder's jpg document cover image in GIMP and resave under the same name (at 100% quality).
 
-
 6. If you ran FLI, exit it. It should stop the Greenstone server.
 
@@ -202,5 +225,5 @@
 	ant start
 
-8. To activate the collection, first visit the web page
+8. Alternatively, to activate the collection, first visit the web page
 http://<host>:<port>/greenstone3/library?a=s&sa=a&st=collection&sn=<COLNAME>
 
@@ -217,6 +240,9 @@
 Deleting a Fedora GS3 collection is accomplished with the following 2 steps:
 
-1. Run the g2f-deletecol.pl script over the collection to be deleted. Assuming the collection is called fedora1, you'd run:
-	g2f-deletecol.pl -hostname localhost -port 8383 -password pounamu -collectdir /<GS3>/web/sites/localsite/collect fedora1
+1. Run the g2f-deletecol.pl script over the collection to be deleted:
+	g2f-deletecol.pl -hostname localhost -port 8383 -password pounamu -collectdir /<GS3>/web/sites/localsite/collect <COLNAME>
+
+(Note: no -removeold flag, otherwise the command is similar to the g2f-import.pl and g2f-buildcol.pl scripts)
+
 2. Manually delete the Greenstone collection directory from the filesystem
 
@@ -224,10 +250,10 @@
 To run this manually, 
 - first remove the pids from the GSearch index:
-/<GS3>/packages/tomcat/webapps/fedoragsearch/client>/<GS3>/packages/tomcat/webapps/fedoragsearch/client/runRESTClient.sh localhost:8383 updateIndex deletePID <greenstone:fedora1-HASH010313b14474bc72b296b15f>
+/<GS3>/packages/tomcat/webapps/fedoragsearch/client>/<GS3>/packages/tomcat/webapps/fedoragsearch/client/runRESTClient.sh localhost:8383 updateIndex deletePID <DOC-PID e.g. greenstone:fedora1-HASH010313b14474bc72b296b15f>
 
 It will ask for the fedoragsearch username and password, which by default are fedoraAdmin and pounamu, respectively.
 
 - then purge the necessary documents (pids) from the fedora repository:
-/<GS3>/ext/fedora3/client/bin>./fedora-purge.sh localhost:8383 fedoraAdmin pounamu greenstone:fedora1-HASHe14e36cba08bd41c663237 http "purging"
+/<GS3>/ext/fedora3/client/bin>./fedora-purge.sh localhost:8383 fedoraAdmin pounamu <DOC-PID e.g. greenstone:fedora1-HASHe14e36cba08bd41c663237> http "purging"
 
 - You can check it's all been deleted by visiting http://localhost:8383/fedora/search 
@@ -263,7 +289,15 @@
 
 - ./install/install.properties.in
+- ./install/server.xml.in
 - ./server/config/spring/akubra-llstore.xml.in
+- ./server/config/spring/web/web.properties.in
 - ./server/config/fedora.fcfg.in
 - ./server/config/fedora-users.xml.in
+
+
+(The following also need to refer to the servername and custom Greenstone tomcat port
+- ./client/bin/fedora-ingest-demos.bat.in
+- ./client/bin/fedora-ingest-demos.sh.in)
+
 
 All these files get converted to filenames without the ".in" suffix upon installation, and placeholder strings in these template files get replaced. The replacements are on the strings 
@@ -394,5 +428,7 @@
 
 The installation process will write out this property into GSearch's FgsConfig/FgsConfigIndexTemplate/Lucene/index.properties: 
-	fgsindex.defaultWriteLockTimeout = 1000
+	fgsindex.defaultWriteLockTimeout = 10000
+
+(Another relevant place to change it would be ./FgsConfig/configDemoOnLucene/fgsconfigFinal/index/FgsIndex/index.properties)
 
 When fedoragsearch then gets deployed, this value will be propagated into: 
@@ -576,19 +612,22 @@
     </filter>
 
-7. Start tomcat to have it deploy fedoragsearch.
+7. Open GSearch's FgsConfig/FgsConfigIndexTemplate/Lucene/index.properties and adjust the lock timeout property to 1000 or 10000 ms:
+	fgsindex.defaultWriteLockTimeout = 10000
+
+8. Start tomcat to have it deploy fedoragsearch.
 This will unpack fedoragsearch.
 
-8. With tomcat running, configure fedoragsearch, which will adjust various config files. You will need to go into the deployed fedoragsearch webapps folder's FgsConfig folder first to be able to run the configuration target:
+9. With tomcat running, configure fedoragsearch, which will adjust various config files. You will need to go into the deployed fedoragsearch webapps folder's FgsConfig folder first to be able to run the configuration target:
 
 	<GS3>/packages/tomcat/webapps/fedoragsearch/FgsConfig>ant -f fgsconfig-basic.xml
 
-9. With tomcat still running, run updateIndex once to create the empty index for the first time (by running the runRESTClient.sh script with the command: "host:port updateIndex createEmpty [indexName]")
+19. With tomcat still running, run updateIndex once to create the empty index for the first time (by running the runRESTClient.sh script with the command: "host:port updateIndex createEmpty [indexName]")
 
 	./<GS3>/packages/tomcat/webapps/fedoragsearch/client/runRESTClient.sh localhost:8383 updateIndex createEmpty FgsIndex
 
-10. Check fedoragsearch has been properly installed by visiting:
+11. Check fedoragsearch has been properly installed by visiting:
 http://localhost:8383/fedoragsearch/rest
 
-10. If you wish to remove the various war files from GS3's tomcat webapps folder, you will need to stop tomcat first before deleting the war files, because doing so when tomcat is running will undeploy those webapps.
+12. If you wish to remove the various war files from GS3's tomcat webapps folder, you will need to stop tomcat first before deleting the war files, because doing so when tomcat is running will undeploy those webapps.
 
 